
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>(转)RabbitMQ消息队列（七）：适用于云计算集群的远程调用(RPC) / 憋错料</title>

    <meta name="description" content="(转)RabbitMQ消息队列（七）：适用于云计算集群的远程调用(RPC) 在云计算环境中,很多时候需要用它其他机器的计算资源,我们有可能会在接收到Message进行处理时,会把一部分计算任务分配到其他节点来完成.那么,RabbitMQ如何使用RPC呢?在本篇文章中,我们将会通过其它节点求来斐波纳契完成示例. 1. 客户端接口 Client interface 为了展示一个RPC服务是如何使用的,我们将创建一段很简单的客户端class. 它将会向外提供名字为call的函数,这个call会发送RPC请求并且阻塞知道收到RPC运算的结果.代码如下: [python] vie">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">(转)RabbitMQ消息队列（七）：适用于云计算集群的远程调用(RPC)</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>在云计算环境中，很多时候需要用它其他机器的计算资源，我们有可能会在接收到Message进行处理时，会把一部分计算任务分配到其他节点来完成。那么，RabbitMQ如何使用RPC呢？在本篇文章中，我们将会通过其它节点求来斐波纳契完成示例。</p>
<h1>1. 客户端接口 Client interface</h1>
<p>为了展示一个RPC服务是如何使用的，我们将创建一段很简单的客户端class。 它将会向外提供名字为call的函数，这个call会发送RPC请求并且阻塞知道收到RPC运算的结果。代码如下：</p>
<p><strong>[python]</strong>&nbsp;<a href="http://blog.csdn.net/anzhsoft/article/details/19633107" rel="external nofollow noreferrer">view plain</a><a href="http://blog.csdn.net/anzhsoft/article/details/19633107" rel="external nofollow noreferrer">copy</a><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL2NvZGUuY3Nkbi5uZXQvYXNzZXRzL0NPREVfaWNvLnBuZw==.jpg" /><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL2NvZGUuY3Nkbi5uZXQvYXNzZXRzL2ljb19mb3JrLnN2Zw==.jpg" /></p>

<ol>
<li>fibonacci_rpc&nbsp;=&nbsp;FibonacciRpcClient()</li>
<li>result&nbsp;=&nbsp;fibonacci_rpc.call(4)</li>
<li>print&nbsp;"fib(4)&nbsp;is&nbsp;%r"&nbsp;%&nbsp;(result,)</li>
</ol>

<h1>2. 回调函数队列 Callback queue</h1>
<p>总体来说，在RabbitMQ进行RPC远程调用是比较容易的。client发送请求的Message然后server返回响应结果。为了收到响应client在publish message时需要提供一个&rdquo;callback&ldquo;（回调）的queue地址。code如下:</p>
<p><strong>[python]</strong>&nbsp;<a href="http://blog.csdn.net/anzhsoft/article/details/19633107" rel="external nofollow noreferrer">view plain</a><a href="http://blog.csdn.net/anzhsoft/article/details/19633107" rel="external nofollow noreferrer">copy</a><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL2NvZGUuY3Nkbi5uZXQvYXNzZXRzL0NPREVfaWNvLnBuZw==.jpg" /><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL2NvZGUuY3Nkbi5uZXQvYXNzZXRzL2ljb19mb3JrLnN2Zw==.jpg" /></p>

<ol>
<li>result&nbsp;=&nbsp;channel.queue_declare(exclusive=True)</li>
<li>callback_queue&nbsp;=&nbsp;result.method.queue</li>
<li>channel.basic_publish(exchange=‘‘,</li>
<li>routing_key=‘rpc_queue‘,</li>
<li>properties=pika.BasicProperties(</li>
<li>reply_to&nbsp;=&nbsp;callback_queue,</li>
<li>),</li>
<li>body=request)</li>
<li>#&nbsp;...&nbsp;and&nbsp;some&nbsp;code&nbsp;to&nbsp;read&nbsp;a&nbsp;response&nbsp;message&nbsp;from&nbsp;the&nbsp;callback_queue&nbsp;...</li>
</ol>

<h2>2.1 Message properties</h2>
<blockquote><p>AMQP 预定义了14个属性。它们中的绝大多很少会用到。以下几个是平时用的比较多的：</p>
<ul>
<li>delivery_mode: 持久化一个Message（通过设定值为2）。其他任意值都是非持久化。请移步<a href="http://blog.csdn.net/anzhsoft/article/details/19607841" rel="external nofollow noreferrer">RabbitMQ消息队列（三）：任务分发机制</a></li>
<li>content_type: 描述mime-type 的encoding。比如设置为JSON编码：设置该property为application/json。</li>
<li>reply_to: 一般用来指明用于回调的queue（Commonly used to name a callback queue）。</li>
<li>correlation_id: 在请求中关联处理RPC响应（correlate RPC responses with requests）。</li>
</ul>
</blockquote>
<h1>3. 相关id Correlation id</h1>
<p>在上个小节里，实现方法是对每个RPC请求都会创建一个callback queue。这是不高效的。幸运的是，在这里有一个解决方法：为每个client创建唯一的callback queue。</p>
<p>这又有其他问题了：收到响应后它无法确定是否是它的，因为所有的响应都写到同一个queue了。上一小节的correlation_id在这种情况下就派上用场了：对于每个request，都设置唯一的一个值，在收到响应后，通过这个值就可以判断是否是自己的响应。如果不是自己的响应，就不去处理。</p>
<h1>4. 总结</h1>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LnJhYmJpdG1xLmNvbS9pbWcvdHV0b3JpYWxzL3B5dGhvbi1zaXgucG5n.jpg" /></p>
<p>工作流程：</p>
<ul>
<li>当客户端启动时，它创建了匿名的exclusive callback queue.</li>
<li>客户端的RPC请求时将同时设置两个properties：&nbsp;reply_to设置为callback queue；correlation_id设置为每个request一个独一无二的值.</li>
<li>请求将被发送到an&nbsp;rpc_queue&nbsp;queue.</li>
<li>RPC端或者说server一直在等待那个queue的请求。当请求到达时，它将通过在reply_to指定的queue回复一个message给client。</li>
<li>client一直等待callback queue的数据。当message到达时，它将检查correlation_id的值，如果值和它request发送时的一致那么就将返回响应。</li>
</ul>
<h1>5. 最终实现</h1>
<p>The code for&nbsp;rpc_server.py:</p>
<p><strong>[python]</strong>&nbsp;<a href="http://blog.csdn.net/anzhsoft/article/details/19633107" rel="external nofollow noreferrer">view plain</a><a href="http://blog.csdn.net/anzhsoft/article/details/19633107" rel="external nofollow noreferrer">copy</a><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL2NvZGUuY3Nkbi5uZXQvYXNzZXRzL0NPREVfaWNvLnBuZw==.jpg" /><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL2NvZGUuY3Nkbi5uZXQvYXNzZXRzL2ljb19mb3JrLnN2Zw==.jpg" /></p>

<ol>
<li>#!/usr/bin/env&nbsp;python</li>
<li>import&nbsp;pika</li>
<li>connection&nbsp;=&nbsp;pika.BlockingConnection(pika.ConnectionParameters(</li>
<li>host=‘localhost‘))</li>
<li>channel&nbsp;=&nbsp;connection.channel()</li>
<li>channel.queue_declare(queue=‘rpc_queue‘)</li>
<li>def&nbsp;fib(n):</li>
<li>if&nbsp;n&nbsp;==&nbsp;0:</li>
<li>return&nbsp;0</li>
<li>elif&nbsp;n&nbsp;==&nbsp;1:</li>
<li>return&nbsp;1</li>
<li>else:</li>
<li>return&nbsp;fib(n-1)&nbsp;+&nbsp;fib(n-2)</li>
<li>def&nbsp;on_request(ch,&nbsp;method,&nbsp;props,&nbsp;body):</li>
<li>n&nbsp;=&nbsp;int(body)</li>
<li>print&nbsp;"&nbsp;[.]&nbsp;fib(%s)"&nbsp;&nbsp;%&nbsp;(n,)</li>
<li>response&nbsp;=&nbsp;fib(n)</li>
<li>ch.basic_publish(exchange=‘‘,</li>
<li>routing_key=props.reply_to,</li>
<li>properties=pika.BasicProperties(correlation_id&nbsp;=&nbsp;\</li>
<li>props.correlation_id),</li>
<li>body=str(response))</li>
<li>ch.basic_ack(delivery_tag&nbsp;=&nbsp;method.delivery_tag)</li>
<li>channel.basic_qos(prefetch_count=1)</li>
<li>channel.basic_consume(on_request,&nbsp;queue=‘rpc_queue‘)</li>
<li>print&nbsp;"&nbsp;[x]&nbsp;Awaiting&nbsp;RPC&nbsp;requests"</li>
<li>channel.start_consuming()</li>
</ol>
<p>The server code is rather straightforward:</p>
<ul>
<li>(4) As usual we start by establishing the connection and declaring the queue.</li>
<li>(11) We declare our fibonacci function. It assumes only valid positive integer input. (Don‘t expect this one to work for big numbers, it‘s probably the slowest recursive implementation possible).</li>
<li>(19) We declare a callback for&nbsp;basic_consume, the core of the RPC server. It‘s executed when the request is received. It does the work and sends the response back.</li>
<li>(32) We might want to run more than one server process. In order to spread the load equally over multiple servers we need to set theprefetch_count&nbsp;setting.</li>
</ul>
<p>The code for&nbsp;rpc_client.py:</p>
<p><strong>[python]</strong>&nbsp;<a href="http://blog.csdn.net/anzhsoft/article/details/19633107" rel="external nofollow noreferrer">view plain</a><a href="http://blog.csdn.net/anzhsoft/article/details/19633107" rel="external nofollow noreferrer">copy</a><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL2NvZGUuY3Nkbi5uZXQvYXNzZXRzL0NPREVfaWNvLnBuZw==.jpg" /><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL2NvZGUuY3Nkbi5uZXQvYXNzZXRzL2ljb19mb3JrLnN2Zw==.jpg" /></p>

<ol>
<li>#!/usr/bin/env&nbsp;python</li>
<li>import&nbsp;pika</li>
<li>import&nbsp;uuid</li>
<li>class&nbsp;FibonacciRpcClient(object):</li>
<li>def&nbsp;__init__(self):</li>
<li>self.connection&nbsp;=&nbsp;pika.BlockingConnection(pika.ConnectionParameters(</li>
<li>host=‘localhost‘))</li>
<li>self.channel&nbsp;=&nbsp;self.connection.channel()</li>
<li>result&nbsp;=&nbsp;self.channel.queue_declare(exclusive=True)</li>
<li>self.callback_queue&nbsp;=&nbsp;result.method.queue</li>
<li>self.channel.basic_consume(self.on_response,&nbsp;no_ack=True,</li>
<li>queue=self.callback_queue)</li>
<li>def&nbsp;on_response(self,&nbsp;ch,&nbsp;method,&nbsp;props,&nbsp;body):</li>
<li>if&nbsp;self.corr_id&nbsp;==&nbsp;props.correlation_id:</li>
<li>self.response&nbsp;=&nbsp;body</li>
<li>def&nbsp;call(self,&nbsp;n):</li>
<li>self.response&nbsp;=&nbsp;None</li>
<li>self.corr_id&nbsp;=&nbsp;str(uuid.uuid4())</li>
<li>self.channel.basic_publish(exchange=‘‘,</li>
<li>routing_key=‘rpc_queue‘,</li>
<li>properties=pika.BasicProperties(</li>
<li>reply_to&nbsp;=&nbsp;self.callback_queue,</li>
<li>correlation_id&nbsp;=&nbsp;self.corr_id,</li>
<li>),</li>
<li>body=str(n))</li>
<li>while&nbsp;self.response&nbsp;is&nbsp;None:</li>
<li>self.connection.process_data_events()</li>
<li>return&nbsp;int(self.response)</li>
<li>fibonacci_rpc&nbsp;=&nbsp;FibonacciRpcClient()</li>
<li>print&nbsp;"&nbsp;[x]&nbsp;Requesting&nbsp;fib(30)"</li>
<li>response&nbsp;=&nbsp;fibonacci_rpc.call(30)</li>
<li>print&nbsp;"&nbsp;[.]&nbsp;Got&nbsp;%r"&nbsp;%&nbsp;(response,)</li>
</ol>
<p>The client code is slightly more involved:</p>
<ul>
<li>(7) We establish a connection, channel and declare an exclusive ‘callback‘ queue for replies.</li>
<li>(16) We subscribe to the ‘callback‘ queue, so that we can receive RPC responses.</li>
<li>(18) The ‘on_response‘ callback executed on every response is doing a very simple job, for every response message it checks if thecorrelation_id&nbsp;is the one we‘re looking for. If so, it saves the response inself.response&nbsp;and breaks the consuming loop.</li>
<li>(23) Next, we define our main&nbsp;call&nbsp;method - it does the actual RPC request.</li>
<li>(24) In this method, first we generate a unique&nbsp;correlation_id&nbsp;number and save it - the ‘on_response‘ callback function will use this value to catch the appropriate response.</li>
<li>(25) Next, we publish the request message, with two properties:&nbsp;reply_to&nbsp;and&nbsp;correlation_id.</li>
<li>(32) At this point we can sit back and wait until the proper response arrives.</li>
<li>(33) And finally we return the response back to the user.</li>
</ul>
<p>开始rpc_server.py：</p>
<p><strong>[python]</strong>&nbsp;<a href="http://blog.csdn.net/anzhsoft/article/details/19633107" rel="external nofollow noreferrer">view plain</a><a href="http://blog.csdn.net/anzhsoft/article/details/19633107" rel="external nofollow noreferrer">copy</a><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL2NvZGUuY3Nkbi5uZXQvYXNzZXRzL0NPREVfaWNvLnBuZw==.jpg" /><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL2NvZGUuY3Nkbi5uZXQvYXNzZXRzL2ljb19mb3JrLnN2Zw==.jpg" /></p>

<ol>
<li>$&nbsp;python&nbsp;rpc_server.py</li>
<li>[x]&nbsp;Awaiting&nbsp;RPC&nbsp;requests</li>
</ol>
<p>通过client来请求fibonacci数:</p>
<p><strong>[python]</strong>&nbsp;<a href="http://blog.csdn.net/anzhsoft/article/details/19633107" rel="external nofollow noreferrer">view plain</a><a href="http://blog.csdn.net/anzhsoft/article/details/19633107" rel="external nofollow noreferrer">copy</a><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL2NvZGUuY3Nkbi5uZXQvYXNzZXRzL0NPREVfaWNvLnBuZw==.jpg" /><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL2NvZGUuY3Nkbi5uZXQvYXNzZXRzL2ljb19mb3JrLnN2Zw==.jpg" /></p>

<ol>
<li>$&nbsp;python&nbsp;rpc_client.py</li>
<li>[x]&nbsp;Requesting&nbsp;fib(30)</li>
</ol>
<p>现在这个设计并不是唯一的，但是这个实现有以下优势：</p>
<ul>
<li>如何RPC server太慢，你可以扩展它:启动另外一个RPC server。</li>
<li>在client端， 无所进行加锁能同步操作，他所作的就是发送请求等待响应。</li>
</ul>
<p>我们的code还是挺简单的，并没有尝试去解决更复杂和重要的问题，比如：</p>
<ul>
<li>如果没有server在运行，client需要怎么做？</li>
<li>RPC应该设置超时机制吗?</li>
<li>如果server运行出错并且抛出了异常，需要将这个问题转发到client吗？</li>
<li>需要边界检查吗？</li>
</ul>
<p><strong>&nbsp;</strong></p>
<p>参考资料：</p>
<p>1. http://www.rabbitmq.com/tutorials/tutorial-six-python.html</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-29 23:08:58 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>(转)RabbitMQ消息队列（七）：适用于云计算集群的远程调用(RPC)的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/49Ae8A4.html" rel="bookmark">RabbitMQ消息队列（七）：适用于云计算集群的远程调用&lpar;RPC&rpar; &lbrack;转&rsqb;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在云计算环境中,很多时候需要用它其他机器的计算资源,我们有可能会在接收到Message进行处理时,会把一部分计算任务分配到其他节点来完成.那么,RabbitMQ如何使用RPC呢?在本篇文章中,我们将会通过其它节点求来斐波纳契完成示例. 1. 客户端接口 Client interface 为了展示一个RPC服务是如何使用的,我们将创建一段很简单的客户端class. 它将会向外提供名字为call的函数,这个call会发送RPC请求并且阻塞知道收到RPC运算的结果.代码如下: [python] vie			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0RkJkY3.html" rel="bookmark">RabbitMQ（七）：适用于云计算集群的远程调用&lpar;RPC&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				﻿﻿ 在云计算环境中,很多时候需要用它其他机器的计算资源,我们有可能会在接收到Message进行处理时,会把一部分计算任务分配到其他节点来完成.那么,RabbitMQ如何使用RPC呢?在本篇文章中,我们将会通过其它节点求来斐波纳契完成示例. 1. 客户端接口 Client interface 为了展示一个RPC服务是如何使用的,我们将创建一段很简单的客户端class. 它将会向外提供名字为call的函数,这个call会发送RPC请求并且阻塞知道收到RPC运算的结果.代码如下: [python]			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/49BAWWM.html" rel="bookmark">千万PV网站架构之RabbitMQ（消息队列）安装、集群</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				RabbitMQ介绍: MQ全称为Message Queue, 消息队列(MQ)是一种应用程序对应用程序的通信方法.应用程序通过读写出入队列的消息(针对应用程序的数据)来通信,而无需专用连接来链接它们.消息传递指的是程序之间通过在消息中发送数据进行通信,而不是通过直接调用彼此来通信,直接调用通常是用于诸如远程过程调用的技术.排队指的是应用程序通过 队列来通信.队列的使用除去了接收和发送应用程序同时执行的要求. RabbitMQ是一个在AMQP基础上完成的,可复用的企业消息系统.他遵循Mozill			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3wpDaR4.html" rel="bookmark">rabbitmq 消息队列</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				rabbitmq 消息队列: 解耦:降低一个程序降低耦合性 异步: 优点:--解决排队的问题. --解决资源浪费的问题.   --讲要处理的事物,进行存放,集中处理. 缺点:--不能保证任务被及时执行 应该场景:--去哪儿网 --12306 同步: 优点:--可以保证任务被及时执行 缺点:--排队问题,占用资源,造成资源浪费 大并发: web环境: --Nginx (epoll模式)   10000-20000 --Apache(epoll模式)1000-2000 pv = page visit			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4AKW9D0.html" rel="bookmark">RabbitMQ 消息队列 应用</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				安装参考    详细介绍   学习参考 RabbitMQ 消息队列 RabbitMQ是一个在AMQP基础上完整的,可复用的企业消息系统.他遵循Mozilla Public License开源协议. MQ全称为Message Queue, 消息队列(MQ)是一种应用程序对应用程序的通信方法.应用程序通过读写出入队列的消息(针对应用程序的数据)来通信,而无需专用连接来链接它们.消息传递指的是程序之间通过在消息中发送数据进行通信,而不是通过直接调用彼此来通信,直接调用通常是用于诸如远程过程调用的技术.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/Mmv6BY0.html" rel="bookmark">Golang调用Rabbitmq消息队列和封装</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言 介绍Rabbimq Rabbitmq消息队列是干嘛的? 简单的说,消息队列,引申一下就是传递消息用的队列,也可以称为传递消息的通信方法.用争抢订单的快车举个例子,假如,A用户发送了一个用车的消息,那么消息队列要做的就是把A用户用车的这个消息广而告之,发送到一个公用队列当中,司机只管取到消息,而不管是谁发布的,这就是一个简单的消息队列例子,Rabbitmq其实就是消息队列的一种,用的比较多的还可能有Redis,kafka,ActiceMq等等,这个后面的博文里面我会说,这次我们只说Rabbi			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MoQxXQ3.html" rel="bookmark">&lpar;转&rpar;RabbitMQ消息队列（六）：使用主题进行消息分发</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在上篇文章RabbitMQ消息队列(五):Routing 消息路由 中,我们实现了一个简单的日志系统.Consumer可以监听不同severity的log.但是,这也是它之所以叫做简单日志系统的原因,因为是仅仅能够通过severity设定.不支持更多的标准. 比如syslog unix的日志工具,它可以通过severity (info/warn/crit...) 和模块(auth/cron/kern...).这可能更是我们想要的:我们可以仅仅需要cron模块的log. 为了实现类似的功能,我们需			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/Mz8E7l3.html" rel="bookmark">RabbitMQ消息队列（六）：使用主题进行消息分发</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在上篇文章RabbitMQ消息队列(五):Routing 消息路由 中,我们实现了一个简单的日志系统.Consumer可以监听不同severity的log.但是,这也是它之所以叫做简单日志系统的原因,因为是仅仅能够通过severity设定.不支持更多的标准. 比如syslog unix的日志工具,它可以通过severity (info/warn/crit...) 和模块(auth/cron/kern...).这可能更是我们想要的:我们可以仅仅需要cron模块的log. 为了实现类似的功能,我们需			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3vvqOg3.html" rel="bookmark">&lpar;转&rpar;RabbitMQ消息队列（九）：Publisher的消息确认机制</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在前面的文章中提到了queue和consumer之间的消息确认机制:通过设置ack.那么Publisher能不到知道他post的Message有没有到达queue,甚至更近一步,是否被某个Consumer处理呢?毕竟对于一些非常重要的数据,可能Publisher需要确认某个消息已经被正确处理. 在我们的系统中,我们没有是实现这种确认,也就是说,不管Message是否被Consume了,Publisher不会去care.他只是将自己的状态publish给上层,由上层的逻辑去处理.如果Message			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/g41yLY4.html" rel="bookmark" class="title">Windows 8 应用程序前后台切换事件监听</a>
					<div>
						在一些情况下,我们需要监听应用程序切换到后台或者从后台切换至前台的事件,从而进行相关处理操作.支付宝应用锁屏(IOS,Android平台)的处理中就需要监听此事件,在用户将应用切换至后台一段时间后再切 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/02bmk20.html" rel="bookmark" class="title">设备和驱动注册过程</a>
					<div>
						设备注册或驱动注册的时候,都会调用总线上的match函数.虽然以前就知道,但是很朦胧,今天就跟了下代码,稍微了解了下,记录在图中.以后有时间再仔细分析. 图很难看,不喜勿喷(屏幕太小,放到一张图上好难 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MGGwAoM.html" rel="bookmark" class="title">shopnc二次开发（二）</a>
					<div>
						一般来说二次开发,多数就是修改界面和增加功能这两个需求 先说修改界面 mvc 架构的程序,在界面这里,基本就是调用数据. 常见的界面数据构架有三种 1.是业务端或者是控制端数据驱动界面,基本上是后台输 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/41gVGo0.html" rel="bookmark" class="title">Nodejs websocket入门</a>
					<div>
						websocket 2011年技术文档 http://www.ibm.com/developerworks/cn/web/1112_huangxa_websocket/index.html 浏览器端接 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MBAJpq4.html" rel="bookmark" class="title">Hive学习之五     《Hive进阶&mdash;UDF操作案例》 详解</a>
					<div>
						hive—UDF操作 udf的操作过程: 在HIVE会话中add 自定义函数的jar文件,然后创建function,继而使用函数. 下面就以下面课题为例: 课题:统计每个活动的PV和UV 一.Java ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mz89xd3.html" rel="bookmark" class="title">javascript中各类高度和宽度的整理</a>
					<div>
						基础学的不扎实,关于高度宽度的各个属性总是糊里糊涂的,在这里理一下思路. 下面的测试以以下html结构为例 &lt;div id=&quot;div1&quot; style=&quot;height ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4Nzr924.html" rel="bookmark" class="title">起码起码大事发生大幅度打分法萨芬</a>
					<div>
						http://f.northnews.cn/archive.php?aid=653086 http://f.northnews.cn/archive.php?aid=653083 http://f.n ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/388ddR3.html" rel="bookmark" class="title">Linux系统的六种运行级别</a>
					<div>
						Linux系统的六种运行级别 0:是关机状态 系统停机模式,系统默认运行级别不能设置为0,否则不能正常启动,机器关闭. 使用范围:密码丢失可以进入单用户级别找回密码  1:是单用户状态 root权限, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MVYaD14.html" rel="bookmark" class="title">linux-CentOS初学terminal命令&lpar;2&rpar;vi</a>
					<div>
						vi filename(vi,visual editor,可视化编辑器)用vim文本编辑器打开filename文件. vim文本编辑器有三种模式:命令模式(Command mode),插入模式(Ins ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0KqB7Y4.html" rel="bookmark" class="title">docker管理神器&mdash;kubernetes&mdash;pod篇</a>
					<div>
						前面介绍了pod是个容器组,那么现在就来创建一个pod,就像dockerfile一样. vi nginx-pod.yaml(要十分注意空格,一般为两个空格) 添加: apiVersion: v1 ki ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0YRqjX3.html" rel="bookmark" class="title">Java与模式：装饰&lpar;Decorator&rpar;模式</a>
					<div>
						装饰模式使用被装饰类的一个子类的实例.把client的调用委派到被装饰类,装饰模式的关键在于这样的扩展是全然透明的. 装饰模式在Java种使用也非常广泛,比方我们在又一次定义button.对话框等时候 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0YRnaX3.html" rel="bookmark" class="title">&lbrack;Android Traffic&rsqb;   使用缓存来避免重复的下载</a>
					<div>
						转载自: http://blog.csdn.net/kesenhoo/article/details/7395817 Redundant Downloads are Redundant[重复下载是冗余 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/41zg6qM.html" rel="bookmark" class="title">微信自带图片浏览js</a>
					<div>
						//下面这个函数用来转换数组到json格式 function arrayToJson(o) { var r = []; if (typeof o == &quot;string&quot;) retu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0a1OLn0.html" rel="bookmark" class="title">year：2017 month：08 day：03</a>
					<div>
						2017-08-03 JAVAse 继承 继承:通过extends关键字可实现类与类之间的继承 父类:基类/超类 子类:派生类 1.继承的特点:单继承[一个类只能有一个父类]多层次[父类还可有父类]  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/M6zZKrM.html" rel="bookmark" class="title">数据挖掘（一）</a>
					<div>
						一.数据的相关问题 数据的质量 数据预处理,使数据更适合分析 根据数据联系分析数据,找到数据之间的联系,利用联系进行其余分析 二.名词解释 数据集:数据对象的集合 属性:对象的性质或特性 测量标度:将 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MGR2wG4.html" rel="bookmark" class="title">锋利的jQuery&mdash;&mdash;DOM对象与jQuery对象的区别</a>
					<div>
						DOM对象 &lt;h3&gt;例子&lt;/h3&gt; &lt;p title=&quot;选择你喜欢的水果&quot;&gt;你最喜欢的水果是?&lt;/p&gt; &lt;ul&gt; &lt ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MBbQEYM.html" rel="bookmark" class="title">jenkins下脚本权限问题</a>
					<div>
						在jenkins环境下,执行需要root权限的脚本,报错. 修改方法: 1. centos环境下,在/etc/sudoers.d/ 目录下,增加一个 jenkins文件,内容如下: Defaults: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4J9Q8l3.html" rel="bookmark" class="title">更简单、更安全的查询方法</a>
					<div>
						//另一种更安全的方法,且解决了查询,分页的问题,以后都应该用这种方法来做 publicfunction manage($n) { $tab = M($n); $Bigtitle = I('Bigti ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPJPV63.html" rel="bookmark" class="title">如何在vs2008安装64位编译器</a>
					<div>
						1.打开D:\Microsoft Visual Studio 9.0\Microsoft Visual Studio 2008 Professional Edition - CHS setup.exe ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3OpwWo4.html" rel="bookmark" class="title">軟實力</a>
					<div>
						一家硅谷公司招来三个实习生,分别是中国人.印度人和美国人.美国实习生只求把事情做完就好,一到下班立马走人.他对一些问题尽管一知半解但也能侃侃而谈,一分钟可以讲完的问题,能讲五分钟.中国实习生很努力,活 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 11 q. 0.033 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
